︠004dabb0-668f-4b13-bfa3-62f438afb7b0s︠
reset
︡ab64893b-0d9f-46c7-8851-fa25d4cc5788︡{"stdout":"<function reset at 0x7f591d340ed8>"}︡{"stdout":"\n"}︡{"done":true}
︠ec4f9a5e-f4dc-4b15-9880-f725575871ea︠
#Exercise 1
#Let g(x)=(1/2)(x+2/x). Consider the simple iteration process x[k+1] = g(x[k]), with initial guess x[0]=a>0.
#(a) Plot the graph of g(x) and the line y = x for in one figure to verify that the positive fixed point p exists. Experiment with initial guess to get a figure showing fixed point.
#(b) Find algebraically the largest set for initial guess (it is called the basin of attaraction) that guarantees convergence of the iteration process.
#(c) Find the positive fixed point exactly.
#(d) Plot in one figure the function g(x), y=x, three iteration points (k, x[k]), k=1..3, with initial guess of your choice, and the fixed point p.
︡b3074205-ea96-4e7d-baac-28ccf92d4afd︡
︠13a0f934-1658-443b-be7f-af95cb838670s︠
g(x)=(1/2)*(x+2/x)
︡72ad5c1f-539b-44f4-b2e6-5f83ffdf0f6a︡{"done":true}
︠15d0b98e-7529-4571-b50a-d999182cd870s︠
#(a)

f_plot=plot(g,0.5,5,figsize=[4,3])
line_plot=line([(0,0), (5,5)])# Learn syntax of the SageMath command line
(f_plot+line_plot).show()
︡951665e6-befe-49f9-8093-2ff33976da6f︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/965/tmp_5G8pS_.svg","show":true,"text":null,"uuid":"ee7ce37c-d77c-4ded-9d08-68493c58e924"},"once":false}︡{"done":true}
︠dbf282f8-bdbc-4e1d-88c0-2d0f91b72462︠
#(b)
# Your work goes here
#x=(sqr(2/3),2i)

#(c)
# Your work goes here
# x^*=sqr(2)

#(d)
# Your work goes here

#############################
︡aa2dcb02-5b63-46fc-be01-46de03423e52︡
︠d2e52cd3-aa93-4073-88e0-72133cc15135︠
#Exercise 2. Make a function simple_iteration(g, a, n) that takes function g, an initial value a, and a positive integer n and returns a list of n iteration points for the fixed point problem x[n+1]=g(x[n]).
#Test your function on the problem in Exercise 1.
︡581392b7-0d83-40d1-80dd-6343cfb57702︡
︠3e375344-130e-4ab5-aa81-5a1f3ba6c0c6s︠
def simple_iteration(g,a,n):
    L=[a]
    for j in range(n):
        temp=g(L[j-1]).n()# Encode the iteration formula here
        L.append(temp)
    return L

#My example
simple_iteration(g,5,7)

︡8a82a46d-ff5c-46b3-8a1e-1b7ff4cebc83︡{"stdout":"[5, 2.70000000000000, 2.70000000000000, 1.72037037037037, 1.72037037037037, 1.44145536817765, 1.44145536817765, 1.41447098136777]\n"}︡{"done":true}
︠4e94fb77-21d2-4dca-8dfc-2a5f94eb5385s︠
#Your example
simple_iteration(g,2,9)

︡852cf5b4-a9e9-4443-be0a-c76dea89e0d0︡{"stdout":"[2, 1.50000000000000, 1.50000000000000, 1.41666666666667, 1.41666666666667, 1.41421568627451, 1.41421568627451, 1.41421356237469, 1.41421356237469, 1.41421356237309]\n"}︡{"done":true}
︠1442dfba-901b-437a-9def-f948063b7bf9︠
######################################

︡46a8189d-53d3-4960-ba48-cc19bdfd1eb5︡
︠699f498d-c841-49ba-97c0-87cc594f5d3fs︠
#Demo: Recursive function for finding nth iterate of the fixed point problem
def nth_iterate(f,a,n):
    b=a
    if n==0:
        return b
    else:
        b=f(b)
        return (nth_iterate(f,b,n-1)).n()

nth_iterate(g,5,4)

︡0d24ac53-d719-4800-8ac5-2aeee5ae7729︡{"stdout":"1.41447098136777\n"}︡{"done":true}
︠30b17bb9-8736-4b6d-b01a-0f9909643069︠
############################
︡e07a2ba0-fa25-43f4-a330-8449016c628d︡
︠82a46c5d-fd1d-4a4e-92d9-d886aff2b7dd︠
#Exercise 3. Modify the fixed point problem in Example 3(b) (see Lecture 8) to design a fixed point iteration process that converges to the root x=-1.697471881. Run the function n_iterates  that you made in Exercise 2 to find ten iteration points. Make a figure similar to Fig. 8.1 with these points.
︡ad7a49c5-fd3d-4e71-b9a3-03ffc181fc16︡
︠d99bca27-e9d1-4082-8003-96990bee1f46︠
###########################
︡39793fc7-5e95-4ccf-904b-6b73600c709c︡
︠b2bce353-5dd3-47a2-8aef-1f27dab34c04︠
#Exercise 4. For one of the functions in Exercise 4 (see Lecture 8) (your choice), do the following.
#(a) Transform the equation into a fixed point problems of the form x=g(x).
#(b) Plot functions y = x, y = g(x) in one figure. Choose a range that incudes the fixed point.
#(c) By visual inspection of the figure that you have made, estimate location of the fixed point and find an interval of initial guess values that ensure convergence of the simpe iteration procedure x[n+1]=g(x[n]). Choose initial guess x0=a in this interval and run the function simple_iteration(g, xini, n) to find ten iteration points. Make a figure similar to Fig. 8.1 in Lecture 8 with these points.

︡a630c216-36bf-4c22-8b60-ca0379b89f27︡
︠86edddac-9d9e-495a-8fed-28f4e85a754as︠
#(a) Your work goes here
var('x')
g(x)=x-sin(x)-1/2
︡735d1e3b-f90e-40aa-9f77-9df54aeb330c︡{"stdout":"x\n"}︡{"done":true}
︠4b6b3556-c258-492a-bb4e-b449945578de︠
#(b) Your work goes here
f_plot=plot(g(x),-3,x,3)
︡0ccd503e-fd10-4422-a268-9b01e2885e80︡{"done":true}
︠5f3e33c6-63b9-48f0-b266-cf80151bbea4︠
#(c) # Your work goes here
(f_plot).show()
Approx=simple_iteration(g,5,10);Approx
︡4ea06fb7-d1f1-47f0-9c54-c7f78be0fec5︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/965/tmp_I9Zgtu.svg","show":true,"text":null,"uuid":"999c872f-f2a5-4a74-bb8f-cfb06e5779bc"},"once":false}︡{"done":true}
︠3667799a-75f8-4e75-ac3e-5e70357a941d︠

︡8b62b29a-c539-4cec-8d74-9bd66fbbc3f5︡
︠605336fa-62c3-4f86-acf0-df100ff45ad9︠
########################
︡de2e2b05-aa6f-481b-b228-4404fe2f0b63︡
︠9406e77d-0347-47f7-a6a8-cc16b560f606︠

# Exercise 5: Newton's method
# Your code takes a function, its derivative, and the initial guess x0=a for a root of the equation f(x)=0. Manual and mental work is needed before running the function in order to choose an initial guess that ensures convergence of the method.
def my_newton(f,fprime,a,eps):#You may choose different stopping criterion
    # Complete the code
︡89e80a88-8960-4512-b6ac-1f10cbea2fb8︡
︠b2299529-0b21-4907-b8d7-c2fa114b8bb8s︠
def my_newton(f,a,n):
fbf2e-0ade-4f2a-8d9a-b3e3d1b11811
︡b5c9303c-331a-4565-a4d8-13ff59264cb8︡
︠71e4704f-17ac-4c27-9b19-705e2d16d492︠
# Useful command: Finding index of an element in a list
L=[1,2,3,4];2 in L
︡da643696-9442-444a-aeeb-c80d8b758936︡{"stdout":"True\n"}︡{"done":true}
︠652a5462-2747-4c7d-b4f6-7d38462113b8︠
L.index(2)
︡4883dd95-61c8-4fe5-93fe-6708ee4a3c7d︡{"stdout":"1\n"}︡{"done":true}
︠77f9d3db-b61e-4ef5-9e05-581ffa2bae4a︠
#Demo (FYI): Finding cube root of x, 0<x<125, by Newton's method
#Note that for x>0 the function x^3-c is growing and concave up. By the rule of thumb, given an interval of the root isolation, the initial guess is set to the right end of the interval.
def cube_root(c,eps):
    L=[j^3 for j in range(1,6)]# List of j^3 to bracket c between two concecutive cubes
    if c in L:
        return L.index(c)+1
    else:
        # Bracket x between two consecutive elements of L
        for j in range(1,5):
            if c<L[j]:
                xold=N(L[j]);xnew=xold-(xold^3-c)/(3.0*xold^2)# MR formula is encoded here
        # Apply Newton's method
        while abs(xold-xnew)>eps:
            xold=xnew
            xnew=xold-(xold^3-c)/(3.0*xold^2)
        return xnew
︡4db6d7e6-24b9-40dd-a71a-26bc3f1da5e0︡{"done":true}
︠cda3ad3e-d409-4ba3-aa03-10d29b3b1fdfs︠
cube_root(83,10^(-3))
︡ff3bdb86-d1c6-4957-9f20-5b05d01826a7︡{"stdout":"4.36207067174020\n"}︡{"done":true}
︠3f3e4215-3e84-433b-af22-35589e9db28cs︠
83.^(1/3)
︡d8e3ac32-d58f-4049-8502-f4ce5f6a987b︡{"stdout":"4.36207067145484\n"}︡{"done":true}
︠5c2081a0-8520-4e47-9646-4fb9f0cf585f︠
#####################
︡d04c6e2e-eb2b-4e22-942d-1c1bac62bc58︡
︠348c5712-4c3f-41ad-8c8a-3ea0ec2a90f3︠
# Mini project: Comparing convergence of the simple iteration method and the Newton-Raphson method
#Consider the function f(x)=exp(-x)*(x^2-5*x-2)+1.
# Do the following
#(a) Plot the function to convince yourself that the function has two roots. Choose one of the roots and use the find_root function to obtain high accuracy value of the root.
#(b) (challenging!) Convert the root-finding problem for f to a fixed point problem g(x)=x with appropriate function g.
#(c) Choose an initial approximation of the root and make a list L with n=5 iterates using simple iteration and a list N with n=5 iterates using NR iterations.
#(d) Make a table with 5 rows for n-values and 3 columns with the table header n, delL[n],and delN[n]. Comment on convergence of these two methods.
︡1eadac08-9ca7-4dde-af48-ef961b0fa360︡
︠7f01b59b-2969-40ee-a327-0ae3b4ea444bs︠
f(x)=exp(-x)*(x^2-5*x-2)+1
plot(f(x),-1,x,3)
︡9c9fe674-06d4-4629-86e4-6defd6b6e980︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/318/tmp_sW1eTO.svg","show":true,"text":null,"uuid":"0e6cb40f-632e-40d5-91d3-5d5594120757"},"once":false}︡{"done":true}
︠09723eb0-c4bc-49a4-a133-94fb87ca7c1fs︠
root1=find_root(f,-1,0);root1
︡d63fc87b-1ace-4c77-b682-0e7ef599eed2︡{"stdout":"-0.23054999321338798"}︡{"stdout":"\n"}︡{"done":true}
︠624c9ffa-2f53-4d40-a897-103ed43aa1f2s︠
root2=find_root(f,1,3);root2
︡b3598294-2b61-4b07-b5c7-f636cba14efe︡{"stdout":"2.0895848494844653\n"}︡{"done":true}
︠86355c0e-0602-48b5-9464-efb4ba0c479as︠
#Useful SageMath command for making a table
table([(x,N(sin(x), digits=2)) for x in [0..3]], header_row=["$x$", r"$\sin(x)$"], frame=True)
︡e303299f-c53f-4bd5-a8a3-5ab47fcb91d5︡{"stdout":"+-----+-----------+\n| $x$ | $\\sin(x)$ |\n+=====+===========+\n| 0   | 0.00      |\n+-----+-----------+\n| 1   | 0.84      |\n+-----+-----------+\n| 2   | 0.91      |\n+-----+-----------+\n| 3   | 0.14      |\n+-----+-----------+\n"}︡{"done":true}
︠4b63e820-5848-4742-8dc5-a04df3e5ece3s︠
#(a)
plot(exp(-x)*(x^2-5*x-2)+1,0,3,figsize=[4,3])
︡71bfb599-8f45-4d03-afb0-4f314745a13f︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/526/tmp_huukDx.svg","show":true,"text":null,"uuid":"42557031-9c1f-4579-95b3-426adccdd562"},"once":false}︡{"done":true}
︠4a6928ee-7949-4c63-b7f0-c379e0580201︠
g1(x)=(x^2+exp(x)-2)/5
︡cccf7d6d-d86f-42ba-8e1d-01499610c322︡
︠d8bb2ecd-d222-40e0-a560-dc047746102b︠
line_plot1=plot(x,-1,0)
g1plot=plot(g1,-1,3,fohsize=[4,3])
g1prime_plot=plot(?,color='red')
(g1plot+g1prime_plot+line_plot1).show()
︡55ecd8b2-8431-4bd8-a3e0-168cf53921bb︡
︠a9115d36-17e9-4734-b8b2-3711db2c363a︠
#(b)
︡71ef6095-4c22-4cc3-bc12-0cd7b30e4d96︡
︠cee7b872-380b-4864-ac0e-0dfb5be1c1ae︠
#(c)
︡26b06a74-5ae2-4392-a750-0c50a7bf651a︡
︠5b70e199-9852-4060-b5ac-585eec529fc8︠
#(d)
︡f07be78d-e66c-4003-a541-f2dd7e371fb4︡
︠dbb59d98-ae9e-49db-8d4b-41ae9ebc77df︠
######################
︡c6b9334d-a406-4693-b277-c53d0d717f00︡
︠f538dbce-bebc-49ab-9e0d-3267c62b4ced︠
# Lab (optional): Exploration of the logistic maps
#Follow the directions in Lecture 8.

# Help file
#//Inputs: Logistic map f_r(x),initial guess u0,number of iterations n
#//Input: range for x: xmin, xmax for plotting
#//Output: cobweb for f(x)
def snail(f,x,u0,n,xmin,xmax):
    u = u0
    P = plot(x, (x, xmin, xmax), color='gray',figsize=[5,3])
    for i in range(n):
        #Learn about command "line" to undertand the plot added to P
        P += line([[u,u],[u,f(u)],[f(u),f(u)]], color = 'red')
        u = f(u)
    P += f.plot(x, xmin, xmax, color='blue')
    P.show()
︡b98c2cba-a6ba-4e0c-80a5-f63e8b0e6742︡{"done":true}
︠a0b9a654-2c71-46cb-b2c5-038f3571ecc8︠

︡6065b9c1-7f32-4ee6-9539-8603707ca0c3︡
︠7126b2d5-081d-4e36-982b-a257f8109dd4︠
︡452b5b74-0b97-41dc-a4dd-7dd0494ed1f1︡{"done":true}
︠660ecfc8-8463-456e-a800-56f85a697835︠

︡89c0db4e-8b51-48b4-8e50-a5e86bcdf385︡
︠74a22e74-af4a-47b8-be55-6634cbf0d185︠












︡6880b843-ca99-4a0f-9abe-35b1b8b6740a︡
︠d9716d6f-6f93-4655-8df4-12718bcbf455s︠
reset
︡742753bb-b131-4395-925f-3534d4e5b44f︡{"stdout":"<function reset at 0x7f591d340ed8>"}︡{"stdout":"\n"}︡{"done":true}
︠10cc1bf4-a0f5-4fbc-b368-82d6fa3e47e1︠
#Exercise 1
#Let g(x)=(1/2)(x+2/x). Consider the simple iteration process x[k+1] = g(x[k]), with initial guess x[0]=a>0.
#(a) Plot the graph of g(x) and the line y = x for in one figure to verify that the positive fixed point p exists. Experiment with initial guess to get a figure showing fixed point.
#(b) Find algebraically the largest set for initial guess (it is called the basin of attaraction) that guarantees convergence of the iteration process.
#(c) Find the positive fixed point exactly.
#(d) Plot in one figure the function g(x), y=x, three iteration points (k, x[k]), k=1..3, with initial guess of your choice, and the fixed point p.
︡2f6330db-360c-4df4-b28a-ced4b63607e9︡
︠a7445ddf-d0a6-4a07-b783-a79f3c977e5ds︠
g(x)=(1/2)*(x+2/x)
︡baef882b-eab8-44fb-9fe2-869fbf351a86︡{"done":true}
︠91091f06-ca55-4c8e-a78f-507013262d3b︠
#(a)

f_plot=plot(?,?,?,figsize=[4,3])
line_plot=line(?,?,?)# Learn syntax of the SageMath command line
(f_plot+line_plot).show()
︡9d816d41-ca7b-4c8d-b3d3-04a57e1fbc2c︡{"done":true}
︠32bcc10e-3c27-468f-8705-ede63bef658c︠
#(b)
# Your work goes here
#(c)
# Your work goes here
#(d)
# Your work goes here

#############################
︡ddf69a69-e59d-451f-a27a-23dd685b0c9e︡
︠659b8b4f-bb4f-446a-9f78-e9e084520c4f︠
#Exercise 2. Make a function simple_iteration(g, a, n) that takes function g, an initial value a, and a positive integer n and returns a list of n iteration points for the fixed point problem x[n+1]=g(x[n]).
#Test your function on the problem in Exercise 1.
︡8bb56503-0727-41f1-8aa5-9e26f21286b5︡
︠bad1af07-271a-4237-856f-253c90080e01︠
def simple_iteration(g,a,n):
    L=[a]
    temp=a
    for j in range(?):
        temp=?.n()# Encode the iteration formula here
        L.append(temp)
    return L

#My example
simple_iteration(g,5,4)

︡d2974a8d-0e00-4357-b76c-412ff7370a65︡{"stdout":"[5, 2.70000000000000, 1.72037037037037, 1.44145536817765, 1.41447098136777]\n"}︡{"done":true}
︠525e1d99-c71e-4842-81a1-940d55680a77︠
#Your example

︡da961207-1483-4a1a-9a59-df82d2b96384︡
︠8042a16e-a311-4244-9082-6e4fb5a9c82a︠
######################################

︡821ecb7f-b282-4177-ba35-ca1b2b9cb4a1︡
︠fa484546-090a-4358-86f2-379b52b34f5ds︠
#Demo: Recursive function for finding nth iterate of the fixed point problem
def nth_iterate(f,a,n):
    b=a
    if n==0:
        return b
    else:
        b=f(b)
        return (nth_iterate(f,b,n-1)).n()

nth_iterate(g,5,4)

︡db329f12-8c12-4dca-937e-25d47a21c43c︡{"stdout":"1.41447098136777\n"}︡{"done":true}
︠0ba021dc-e1e7-4f5b-acb3-c99383475a98︠
############################
︡9a7c03cf-b7d4-4bde-9f89-3b7057dcbda0︡
︠18fc2cb2-e31c-4a52-b956-88d8bb8022ef︠
#Exercise 3. Modify the fixed point problem in Example 3(b) (see Lecture 8) to design a fixed point iteration process that converges to the root x=-1.697471881. Run the function n_iterates  that you made in Exercise 2 to find ten iteration points. Make a figure similar to Fig. 8.1 with these points.
︡a5063bba-89f2-46c9-951a-3d64f3c0d902︡
︠2a7d36d8-eb85-46ce-b36b-0f8803ad8829︠
###########################
︡12209ae3-131a-44e4-9192-6e4859390e05︡
︠bf9121fc-1da1-42c2-94f3-a027688e529c︠
#Exercise 4. For one of the functions in Exercise 4 (see Lecture 8) (your choice), do the following.
#(a) Transform the equation into a fixed point problems of the form x=g(x).
#(b) Plot functions y = x, y = g(x) in one figure. Choose a range that incudes the fixed point.
#(c) By visual inspection of the figure that you have made, estimate location of the fixed point and find an interval of initial guess values that ensure convergence of the simpe iteration procedure x[n+1]=g(x[n]). Choose initial guess x0=a in this interval and run the function simple_iteration(g, xini, n) to find ten iteration points. Make a figure similar to Fig. 8.1 in Lecture 8 with these points.

︡054314ac-c43d-4d02-86b4-028bb883caf6︡
︠41d14ea5-c2fe-46d4-94c8-42e09d3315d1︠
#(a) Your work goes here
︡381358ad-1893-4426-817a-a99b50d19129︡
︠650d6519-2576-4882-9f75-050580ce9b06︠
#(b) Your work goes here
︡55cc5c22-55ab-4c70-b049-c2e25ea1a20a︡
︠9326e3e3-c6d6-4aaa-9d65-38a9306a7285︠
#(c) # Your work goes here
︡9670adc8-7a80-4535-a097-7d928e8645af︡
︠3120011e-7fda-497a-9c0f-18bc626642d2︠
########################
︡a70127e8-cf3a-40b4-a0f6-2efb03f3f95e︡
︠714cf79c-3fbd-484a-ba50-dce4153ceebf︠

# Exercise 5: Newton's method
# Your code takes a function, its derivative, and the initial guess x0=a for a root of the equation f(x)=0. Manual and mental work is needed before running the function in order to choose an initial guess that ensures convergence of the method.
def my_newton(f,fprime,a,eps):#You may choose different stopping criterion
    # Complete the code
︡e3f34ff6-71f8-4ab0-9273-07f2c32fbbac︡
︠1728d075-f631-4cd8-8549-287553b3dbe6︠

︡7b0e6db9-5e38-4197-96e5-190bd13a5586︡
︠5efbbebd-7790-4a4e-b76d-e43d11c8d33b︠
# Useful command: Finding index of an element in a list
L=[1,2,3,4];2 in L
︡0a3f8b6d-c92b-4a97-b0aa-41406beee9d4︡{"stdout":"True\n"}︡{"done":true}
︠e2a519bf-0a75-4110-ab1b-07f542af0eea︠
L.index(2)
︡b71cd16b-08ba-48f7-998d-204f83dd2cb2︡{"stdout":"1\n"}︡{"done":true}
︠3c94c65f-2d1c-45be-aee9-1b56136826e6︠
#Demo (FYI): Finding cube root of x, 0<x<125, by Newton's method
#Note that for x>0 the function x^3-c is growing and concave up. By the rule of thumb, given an interval of the root isolation, the initial guess is set to the right end of the interval.
def cube_root(c,eps):
    L=[j^3 for j in range(1,6)]# List of j^3 to bracket c between two concecutive cubes
    if c in L:
        return L.index(c)+1
    else:
        # Bracket x between two consecutive elements of L
        for j in range(1,5):
            if c<L[j]:
                xold=N(L[j]);xnew=xold-(xold^3-c)/(3.0*xold^2)# MR formula is encoded here
        # Apply Newton's method
        while abs(xold-xnew)>eps:
            xold=xnew
            xnew=xold-(xold^3-c)/(3.0*xold^2)
        return xnew
︡ac368468-e489-4d76-b2f6-db83c0cbff40︡{"done":true}
︠1299196e-6ec9-472f-9991-2bde293c9716s︠
cube_root(83,10^(-3))
︡2c792ae2-3183-4775-925d-d626cbf53120︡{"stdout":"4.36207067174020\n"}︡{"done":true}
︠b1d3db5f-1e2b-4b0f-9a2a-227e0f1a61b9s︠
83.^(1/3)
︡06195b16-4699-4d98-89cd-e42e12baccf5︡{"stdout":"4.36207067145484\n"}︡{"done":true}
︠801c6235-4bf8-4c10-ad7e-af87ece17a87︠
#####################
︡c45dad69-73cd-4ecf-a486-5cfff14a6d22︡
︠1c99431b-93b3-45eb-9d65-76ef016dea43︠
# Mini project: Comparing convergence of the simple iteration method and the Newton-Raphson method
#Consider the function f(x)=exp(-x)*(x^2-5*x-2)+1.
# Do the following
#(a) Plot the function to convince yourself that the function has two roots. Choose one of the roots and use the find_root function to obtain high accuracy value of the root.
#(b) (challenging!) Convert the root-finding problem for f to a fixed point problem g(x)=x with appropriate function g.
#(c) Choose an initial approximation of the root and make a list L with n=5 iterates using simple iteration and a list N with n=5 iterates using NR iterations.
#(d) Make a table with 5 rows for n-values and 3 columns with the table header n, delL[n],and delN[n]. Comment on convergence of these two methods.
︡45c88424-d8e1-4aed-bd28-d269e8a270d7︡
︠7a33e4a3-2dd9-4689-86b1-e841a198ea34s︠
#Useful SageMath command for making a table
table([(x,N(sin(x), digits=2)) for x in [0..3]], header_row=["$x$", r"$\sin(x)$"], frame=True)
︡32068f73-7670-44a5-833a-a64bfa36cfd8︡{"stdout":"+-----+-----------+\n| $x$ | $\\sin(x)$ |\n+=====+===========+\n| 0   | 0.00      |\n+-----+-----------+\n| 1   | 0.84      |\n+-----+-----------+\n| 2   | 0.91      |\n+-----+-----------+\n| 3   | 0.14      |\n+-----+-----------+\n"}︡{"done":true}
︠bc81cee5-c093-4e2b-a8da-80b8ecf52246︠
#(a)
plot(exp(-x)*(x^2-5*x-2)+1,?,?,figsize=[4,3])
︡dfa9d3f3-8f15-4409-bee7-1747a561644b︡{"done":true}
︠b40faedb-abdf-4602-9ef1-871cd2d935ca︠
#(b)
︡d1a80319-eabe-466b-8a36-de492567ed7e︡
︠2fd43d3e-c7a2-4eff-a17c-57c7a5ee2062︠
#(c)
︡a6521051-704d-4205-8d62-182ed304638a︡
︠ab69ab4f-1be9-4a8f-acc8-0529324133ee︠
#(d)
︡aa0086bb-5f13-42a3-b3fe-902473a09e8c︡
︠5dae7b14-6b7a-4a05-b756-dd5d34a7063b︠
######################
︡7fab3796-1913-41e7-807e-56895c669b19︡
︠8dc37179-288c-403b-be80-cd38ed1eee33︠
# Lab (optional): Exploration of the logistic maps
#Follow the directions in Lecture 8.

# Help file
#//Inputs: Logistic map f_r(x),initial guess u0,number of iterations n
#//Input: range for x: xmin, xmax for plotting
#//Output: cobweb for f(x)
def snail(f,x,u0,n,xmin,xmax):
    u = u0
    P = plot(x, (x, xmin, xmax), color='gray',figsize=[5,3])
    for i in range(n):
        #Learn about command "line" to undertand the plot added to P
        P += line([[u,u],[u,f(u)],[f(u),f(u)]], color = 'red')
        u = f(u)
    P += f.plot(x, xmin, xmax, color='blue')
    P.show()
︡1899e8fb-c94b-40d9-8c5d-c5bf513103c2︡{"done":true}
︠432834ba-2293-4a38-9a1f-24c2aece3a39︠

︡cdc0b6f2-2aa9-4a97-a2d6-590a2ff62ae4︡
︠e01fcc98-cf1d-425e-98b2-e5d63d6b3317︠
︡c9389a44-5723-44fa-9dee-5cabd8338c65︡{"done":true}
︠3b0637ae-2d1e-4d37-b71a-210c5d27d911︠

︡447ad359-d9ad-4684-8010-6e3803cb957b︡
︠6ca9b056-0e83-498e-acf1-035a4fd316fa︠












